class MutBotBooster extends Mutator;

// Sole goal of this mutator: Replace the Booster combo with one that
// doesn't bug on health greater than SuperHealthMax.  It also does
// the replacement for bots, too.

var bool bInitialized;

function Initialize()
{
	bInitialized = True;
	Spawn(class'BotBooster.BoosterReplication');
}

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	local xPlayer xpl;
	local int c;

	bSuperRelevant = 0;

	if (!bInitialized)
		Initialize();

	if ( Other.IsA('Combo') )
	{
		if ( Other.IsA('ComboDefensive') && !Other.IsA('DruidComboDefensive'))
		{
			ReplaceWith(ComboDefensive(Other), "BotBooster.BotComboDefensive");
		}
	}
	if(Bot(Other) != None)
	{
		for(c = 0; c < ArrayCount(Bot(Other).ComboNames); c++ )
		{
			if(Bot(Other).ComboNames[c] ~= "XGame.ComboDefensive" )
			{
				Bot(Other).ComboNames[c] = "BotBooster.BotComboDefensive";
				break;
			}
		}
	}
// I'm not sure this has to be here - I know if the similar code in
// ModifyPlayer wasn't there, things don't work 100% as desired.
// NoInvis had a similar stanza but not one in ModifyPlayer ...
	if(xPlayer(Other) != None && Level.NetMode != NM_DedicatedServer)
	{
		xpl = xPlayer(Other);
		for (c = 0; c < ArrayCount(xpl.ComboList); c++)
		{
			if(xpl.ComboNameList[c] ~= "XGame.ComboDefensive")
			{
				xpl.ComboNameList[c] = "BotBooster.BotComboDefensive";
				xpl.ComboList[c] = class<Combo>( DynamicLoadObject("BotBooster.BotComboDefensive", class'Class' ) );
				xpl.MinAdrenalineCost = FMin(xpl.MinAdrenalineCost, xpl.ComboList[c].Default.AdrenalineCost);
				break;
			}
		}
	}
	return true;
}

function ModifyPlayer(Pawn Other)
{
	local xPawn xp;
	local xPlayer xpl;
	local int c;

	Super.ModifyPlayer(Other);

	xp = xPawn(Other);
	if(xp == None)
		return;
	xpl = xPlayer(xp.Controller);
	if(xpl == none)
		return;
	for(c = 0; c < ArrayCount(xpl.ComboList); c++)
	{
		if(xpl.ComboNameList[c] ~= "XGame.ComboDefensive")
		{
			xpl.ComboNameList[c] = "BotBooster.BotComboDefensive";
			xpl.ComboList[c] = class<Combo>( DynamicLoadObject("BotBooster.BotComboDefensive", class'Class' ) );
			xpl.MinAdrenalineCost = FMin(xpl.MinAdrenalineCost, xpl.ComboList[c].Default.AdrenalineCost);
			break;
		}
	}
}

defaultproperties
{
	GroupName="BotBooster"
	FriendlyName="Bot's Booster"
	Description="Bot's Booster Combo Replacement"
}
